/* M a i n l i n e                                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.13A */

#ifdef __USAGE
%C - This is a QNX/Photon Application.
%C [options]

Options:
  -s server   Server node or device name
  -x x        Initial x position
  -y y        Initial y position
  -h h        Initial h dimension
  -w w        Initial w dimension

Examples:
%C -s4
  Run using Photon server on node 4

%C -s//4/dev/photon
  Same as above

%C -x10 -y10 -h200 -w300
  Run at initial position 10,10 with initial 
  dimension of 200x300.
#endif

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"
#include "abwidgets.h"
#include "ablinks.h"
#include "abdefine.h"
#include "abevents.h"
#include "abvars.h"

/* AppBuilder globals */
char		ab_exe_path[PATH_MAX];

static void ApClassInit( void );

void
main ( int argc, char *argv[] )

	{

	ab_winstate = 0;

	/* AppBuilder Initialization */
	ApInitialize( argc, argv );

	/* Setup class table used by this application */
	ApClassInit( );

	life_init( argc, argv );

	/* Display main window */

	/* Loop until user quits application */
	PtMainLoop( );

	}

static void
ApClassInit( void )

	{

	ApAddClass( "PtWindow", &PtWindow );
	ApAddClass( "PtDBContainer", &PtDBContainer );
	ApAddClass( "PtScrollArea", &PtScrollArea );
	ApAddClass( "PtRect", &PtRect );
	ApAddClass( "PtBitmap", &PtBitmap );
	ApAddClass( "PtPane", &PtPane );
	ApAddClass( "PtLabel", &PtLabel );
	ApAddClass( "PtScrollbar", &PtScrollbar );
	ApAddClass( "PtMenuBar", &PtMenuBar );
	ApAddClass( "PtMenuButton", &PtMenuButton );
	ApAddClass( "PtMenu", &PtMenu );
	ApAddClass( "PtGroup", &PtGroup );
	ApAddClass( "PtMultiText", &PtMultiText );
	ApAddClass( "PtButton", &PtButton );
	ApAddClass( "PtSeparator", &PtSeparator );
	ApAddClass( "PtNumericInteger", &PtNumericInteger );
	ApAddClass( "PtText", &PtText );
	ApAddClass( "PtToggleButton", &PtToggleButton );
	ApAddClass( "PtList", &PtList );
	ApAddClass( "RtProgress", &RtProgress );
	ApAddClass( "PtPolygon", &PtPolygon );

	}
