; ----------------------------------------------------------------
;
; Not really optimized... It was a first draft
;
; 	FOR each column [1..99] DO
;		FOR each row [0..598] DO
;			FOR each bit inside the byte
;				compute the number of neigbors
;				IF the current cell is living 
;					IF there are 2 or 3 neighbors
;						this is a survival cell
;					ELSE
;						this is a death cell
;				ELSE
;					IF there are 3 neighbors
;						this is a birth cell
;		ENDFOR row
;	ENDFOR column
;
; ----------------------------------------------------------------

		.386p

lrules_struct	struc
	lrules_births		db	?			; Births definition
	lrules_births_prob	db 8 dup (?)	; Births probabilities
	lrules_deaths		db	?			; Deaths definition
	lrules_deaths_prob	db 8 dup (?)	; Deaths probabilities
	lrules_surviv		db	?			; Surviving definition
	lrules_surviv_prob	db 8 dup (?)	; Surviving probabilities
lrules_struct	ends


; -----------------------------
; Local variable to this module
; -----------------------------

_DATA	segment para public use32

row			dd		0
col			dd		0

src			dd		0
dst			dd		0

new_opt_x1	dd		0
new_opt_x2	dd		0
new_opt_y1	dd		0
new_opt_y2	dd		0

lrules_mask	db		000h, 001h, 002h, 004h, 008h, 010h, 020h, 040h, 080h

_DATA	ends
	

; ------------
; Code segment
; ------------

_TEXT	segment para public use32
		assume cs:code32, ds:data32, ss:code32

global 	compute_gen_:			proc
global	bitmap_to_bytenibble_:	proc
global	genmove_:				proc
global	gencopy_:				proc
global	gencmp_:				proc

; Defined into life.h
extrn	_Population:dword;
extrn	_births:dword;
extrn	_deaths:dword;
extrn	_surviv:dword;

; Life Rules
extrn	_is_std_rules:dword;
extrn	_wrk_lrules:lrules_struct;

; Optimization window
extrn	_opt_x1:dword;
extrn	_opt_x2:dword;
extrn	_opt_y1:dword;
extrn	_opt_y2:dword;


; ----------------
; Clear a register
; ----------------
clr		macro	reg
		xor		reg, reg
		endm


; --------------------------
; Increment a dword variable 
; --------------------------

incr	macro	reg
		inc		dword ptr [reg]
		endm


; -------------------------
; Update the seeking window
; -------------------------

opti		macro
	
			local	ll1, ll2, ll3, ll4;

			; Update opt_x1: if (col < opt_x1) opt_x1 = col;
			mov		eax, [col]
			cmp		eax, [new_opt_x1]
			jae		ll1
			mov		[new_opt_x1], eax
ll1:

			; Update opt_x2: if (col > opt_x2) opt_x2 = col;
			cmp		eax, [new_opt_x2]
			jbe		ll2
			mov		[new_opt_x2], eax
ll2:

			; Update opt_y1: if (row < opt_y1) opt_y1 = row;
			mov		eax, [row]
			cmp		eax, [new_opt_y1]
			jae		ll3
			mov		[new_opt_y1], eax
ll3:

			; Update opt_y2: if (row > opt_y2) opt_y2 = row;
			cmp		eax, [new_opt_y2]
			jbe		ll4
			mov		[new_opt_y2], eax
ll4:

			endm


; ---------------------------------------
;	DL  : number of neighbors
;	ESI : pointer to the current cell 
; ---------------------------------------
report_stdrules	macro	m1, m2

			local	exist, not_exist
			local	surviv, birth, death
			local	ok, nok, next

			; Does the current cell exists ?
			mov		al, [esi]
			and		al, m1
			je		not_exist

			; Yes: current cell is living here					
exist:		cmp		dl, 2
			je		surviv						; If 2 neighbors, cell survives
			cmp		dl, 3
			jne		death						; If 3 neighbors, cell survives
			
surviv:		incr	[_surviv]
			opti
			jmp		ok
	
death:		incr	[_deaths]					; If <= 1 or >3 neighbors, cell deads
			jmp		nok

			; No: current cell not living here			
not_exist:	cmp		dl, 3
			je		birth

nok:		and		byte ptr [edi], m2
			jmp		next

birth:		incr	[_births]					; A birth in a free cell with 3 neighbors
			opti

ok:			or		byte ptr [edi], m1
			incr	[_Population]

next:			
			endm


; ---------------------------------------
;	EDX : number of neighbors
;	ESI : pointer to the current cell 
; ---------------------------------------
report_nonstdrules	macro	m1, m2

			local	exist, not_exist
			local	surviv, birth, death
			local	ok, nok, next

			; Does the current cell exists ?
			mov		al, [esi]
			and		al, m1
			je		not_exist

			; YES : current cell is living here					
exist:		
		mov		al, [_wrk_lrules.lrules_surviv]
			mov		al, [lrules_mask + edx]
			and		al, [_wrk_lrules.lrules_surviv]
			jz		death						; If 3 neighbors, cell survives
			
surviv:		incr	[_surviv]
			opti
			jmp		ok
	
death:		incr	[_deaths]					; If <= 1 or >3 neighbors, cell deads
			jmp		nok

			; NO : current cell not living here	
not_exist:	
			mov		al, [lrules_mask + edx]
			and		al, [ebp.lrules_births]
			jnz		birth

nok:		and		byte ptr [edi], m2
			jmp		next

birth:		incr	[_births]					; A birth in a free cell with 3 neighbors
			opti

ok:			or		byte ptr [edi], m1
			incr	[_Population]

next:			
			endm


; +---+---+---+
; | A | B | C |       Life field is 800 (width) x 600 (height)
; +---+---+---+
; | D | . | F |       Each cell is a bit. So a complete row is 100 bytes (800 >> 3)
; +---+---+---+
; | G | H | I |
; +---+---+---+

do_comp_gen			macro which_report

					; 1/8
					mov		dl, [esi-101]		; A
					and		dl, 001h
					mov		al, [esi-100]		; B
					shr		al, 7
					add		dl, al
					mov		al, [esi-100]		; C
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi-1]			; D
					and		al, 001h
					add		dl, al
					mov		al, [esi]			; F
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi+99]		; G
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]		; H
					shr		al, 7
					add		dl, al
					mov		al, [esi+100]		; I
					shr		al, 6
					and		al, 001h
					add		dl, al
					which_report	080h, 07Fh

					; 2/8
					mov		dl, [esi-100]			; A
					shr		dl, 7
					mov		al, [esi-100]			; B
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]			; C
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi]				; D
					shr		al, 7
					add		dl, al
					mov		al, [esi]				; F
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]			; G
					shr		al, 7
					add		dl, al
					mov		al, [esi+100]			; H
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]			; I
					shr		al, 5
					and		al, 001h
					add		dl, al
					which_report	040h, 0BFh

					; 3/8
					mov		dl, [esi-100]				; A
					shr		dl, 6
					and		dl, 001h
					mov		al, [esi-100]				; B
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]				; C
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; F
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 6
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; I
					shr		al, 4
					and		al, 001h
					add		dl, al
					which_report	020h, 0DFh

					; 4/8					
					mov		dl, [esi-100]				; A
					shr		dl, 5
					and		dl, 001h
					mov		al, [esi-100]				; B
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]				; C
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; F
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 5
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; I
					shr		al, 3
					and		al, 001h
					add		dl, al
					which_report	010h, 0EFh

					; 5/8
					mov		dl, [esi-100]				; A
					shr		dl, 4
					and		dl, 001h
					mov		al, [esi-100]				; B
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]				; C
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; F
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 4
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; I
					shr		al, 2
					and		al, 001h
					add		dl, al
					which_report	008h, 0F7h


					; 6/8
					mov		dl, [esi-100]				; A
					shr		dl, 3
					and		dl, 001h
					mov		al, [esi-100]				; B
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]				; C
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; F
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 3
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; I
					shr		al, 1
					and		al, 001h
					add		dl, al
					which_report	004h, 0FBh


					; 7/8
					mov		dl, [esi-100]				; A
					shr		dl, 2
					and		dl, 001h
					mov		al, [esi-100]				; B
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi-100]				; C
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; F
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 2
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; I
					and		al, 001h
					add		dl, al
					which_report	002h, 0FDh


					; 8/8
					mov		dl, [esi-100]				; A
					shr		dl, 1
					and		dl, 001h
					mov		al, [esi-100]				; B
					and		al, 001h
					add		dl, al
					mov		al, [esi-99]				; C
					shr		al, 7
					and		al, 001h
					add		dl, al
					mov		al, [esi]					; D
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi+1]					; F
					shr		al, 7
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; G
					shr		al, 1
					and		al, 001h
					add		dl, al
					mov		al, [esi+100]				; H
					and		al, 001h
					add		dl, al
					mov		al, [esi+101]				; I
					shr		al, 7
					and		al, 001h
					add		dl, al
					which_report	001h, 0FEh

					endm


m_compute_gen		macro which_report

					local	RestartRow, Process_8cells;
					local	NextCol, NextRow;

					mov		[src], esi
					mov		[dst], edi

					clr		eax
					mov		ecx, (800*600)/(8*4)
					cld
					repnz stosd

					mov		eax, 07FFFFFFFh
					mov		[new_opt_x1], eax
					clr		eax
					mov		[new_opt_x2], eax

					mov		eax, 07FFFFFFFh
					mov		[new_opt_y1], eax
					clr		eax
					mov		[new_opt_y2], eax

					clr		eax
					mov		[_Population], eax
					mov		[_births], eax
					mov		[_deaths], eax
					mov		[_surviv], eax

					mov		eax, [_opt_y1]
					mov		[row], eax

					clr		edx

RestartRow:			mov		eax, [_opt_x1]
					mov		[col], eax

					mov		esi, [row]
					imul	esi, 100
					mov		eax, [col]
					add		esi, eax
					add		esi, [src]

					mov		edi, [row]
					imul	edi, 100
					mov		eax, [col]
					add		edi, eax
					add		edi, [dst]


Process_8cells:
					do_comp_gen which_report
		
NextCol:			inc		[col]
					mov		eax, [col]
					mov		ebx, [_opt_x2]
					cmp		eax, ebx
					ja		NextRow

					inc		esi
					inc		edi
					jmp		Process_8cells;

NextRow:			inc		[row]
					mov		eax, [row]
					mov		ebx, [_opt_y2]
					cmp		eax, ebx
					jbe		RestartRow

					mov		eax, [new_opt_x1]
					mov		[_opt_x1], eax
					mov		eax, [new_opt_x2]
					mov		[_opt_x2], eax

					mov		eax, [new_opt_y1]
					mov		[_opt_y1], eax
					mov		eax, [new_opt_y2]
					mov		[_opt_y2], eax

					endm


compute_gen_		proc

					cmp [_is_std_rules], 0
					jz		non_std_rules
std_rules:			m_compute_gen report_stdrules
					ret
non_std_rules:		push ebp
					lea	ebp, _wrk_lrules
					m_compute_gen report_nonstdrules
 					pop ebp
					ret

compute_gen_		endp



; ---------------------------------------------
; bitmap_to_bytenibble_
;
; Convert a bitmap (1 bit / pixel) to an image, 
; byte/nibble format (4 bits / pixel)
; ---------------------------------------------

bw			macro	reg

			local	black, white, done

			jne		black
white:		mov		reg, 00h
			jmp		done
black:		mov		reg, 01h
done:

			endm


nibble		macro

			shl		bl, 4
			add		cl, bl
			mov		[edi], cl
			inc		edi

			endm

bitmap_to_bytenibble_	proc

					mov		edx, ((800/8)*600)

convert:			mov		al, [esi]
					mov		bl, al
					shr		bl, 7				; Bit #0
					bw		bl

					mov		cl, al
					shr		cl, 6
					and		cl, 01h				; Bit #1
					bw		cl
					
					nibble

					mov		bl, al
					shr		bl, 5
					and		bl, 01h				; Bit #2
					bw		bl

					mov		cl, al
					shr		cl, 4
					and		cl, 01h				; Bit #3
					bw		cl

					nibble
					
					mov		bl, al
					shr		bl, 3
					and		bl, 01h				; Bit #4
					bw		bl

					mov		cl, al
					shr		cl, 2
					and		cl, 01h				; Bit #5
					bw		cl
					
					nibble

					mov		bl, al
					shr		bl, 1
					and		bl, 01h				; Bit #6
					bw		bl

					mov		cl, al
					shr		cl, 0
					and		cl, 01h				; Bit #7
					bw		cl
					
					nibble						; Nibble #3

					inc		esi
					dec		edx
					jne		convert					
					
					ret
bitmap_to_bytenibble_	endp


; ---------------------------------------------------------------------------
; genmove
;
; Object:	Do the same as: memmove( dst, src, FIELD_SIZE )
;
; I)	destination address
;		source address
;
; Note)	Arguments are given on the stack, not in register
; ---------------------------------------------------------------------------

genmove_		proc
	
				push	es
				push	ds
				pop		es

				mov		ecx, (800*600)/(8*4)
				cld
genmove_copy:	lodsd		
				stosd
				loop genmove_copy

				pop		es
				ret

genmove_		endp
					

gencopy_		proc
	
				push	es
				push	ds
				pop		es

				cld
gencopy_copy:	lodsd		
				stosd
				loop gencopy_copy

				pop		es
				ret

gencopy_		endp
					


gencmp_			proc

				mov		ecx, (800*600)/(8*4)
				mov		edx, 4
				cld
gencmp_2:		lodsd		
				mov		ebx, [edi]
				add		edi, edx
				cmp		eax, ebx
				jne		gencmp_diff
				loop gencmp_2

gencmp_equ:		clr		eax
				ret

gencmp_diff:	clr		eax
				dec		eax
				ret

gencmp_			endp
					


_TEXT		ends
			end
