
/* ../abmain.c */
void main ( int argc , char *argv []);

/* ../about.c */
int about_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int about_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../drag_pan.c */
int refresh_zoom ( void *data , pid_t pid , void *msg , ushort_t size );
int start_drag_pan ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int drag_pan_cb ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../file_exit.c */
int readandset_cfg_szpos ( char *section , PtWidget_t *wgt );
int save_posdim_in_config_file ( char *section , PtWidget_t *wgt );
int read_cfg_options ( void );
int file_exit ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../file_load.c */
int file_load ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../file_save.c */
int file_save ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int file_save_text ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../graph.c */
void graph_redraw ( void );
void new_graph_data ( const int gen , const USHORT pop , const USHORT births , const USHORT deaths , const USHORT surviv );
int graph_resize ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_show_pop ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_show_births ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_show_deaths ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_show_surviv ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graph_opening ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int graphs_infos_filter ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../help.c */
int help_about ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int help_rules ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int life_about ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life.c */
int life_stats ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int life_graph ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int life_seek ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_btn_stop.c */
int life_btn_stop ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_button_press.c */
int life_button_press ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_center_gen.c */
int life_center_gen ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_center_zoom.c */
void do_life_center ( void );
int life_center_zoom ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_clear.c */
void do_life_clear ( void );
int life_clear ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_init.c */
void set_zoom_yscrollbar ( const int new_pos );
void set_zoom_xscrollbar ( const int new_pos );
void resize_pan ( void );
UBYTE *bitmap_to_use ( void );
void clear_field ( void );
void show_life ( const int no );
int count_nb_cells ( const UBYTE *bitmap );
void find_pos_gen ( const UBYTE *bitmap , int *x1 , int *x2 , int *y1 , int *y2 );
void slog ( const char *fmt , ...);
int life_init ( int argc , char *argv []);

/* ../life_opening.c */
int life_opening ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_resize.c */
int life_resize ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_restoregen0.c */
int life_restoregen0 ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../life_setup.c */
int life_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../lrules.c */
void show_which_rules ( void );
void create_std_rule ( LRULES *lrules );
int lrules_standard ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_btn_cancel ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_useprob ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_btn_ok ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_realized ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_define ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int status_lrules ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int lrules_deaths ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../next_gen.c */
void do_compute_next_gen ( const BOOL is_fast );
int next_gen ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../next_generations.c */
int next_generations ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../options.c */
int options_grid ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int options_grid_racc ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int options_settings ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int options_double_buffer ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../prev_gen.c */
int prev_gen ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../print.c */
int file_print ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int print_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void do_print ( void );
int print_btn_print ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../rules.c */
int rules_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int rules_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int rules_resize ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_btn_genrnd.c */
void compute_random_generation ( int tsize_width1 , int tsize_width2 , int tsize_height1 , int tsize_height2 , int pop_min , int pop_max );
int seek_btn_genrnd ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_btn_reloadbestgen.c */
int seek_btn_reloadbestgen ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_btn_reloadstartgen.c */
void seek_do_reloadgen ( UBYTE *gen_kept , PtWidget_t *wgt );
int seek_btn_reloadstartgen ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_btn_start.c */
int seek_btn_start ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_destroyed.c */
int seek_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_is_showstats.c */
int seek_is_showstats ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_is_showzoom.c */
int seek_is_showzoom ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../seek_setup.c */
int restore_values_ini ( void );
int seek_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../settings.c */
int settings_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int settings_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int settings_btn_ok ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int settings_nbgen_kept ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../stats.c */
void show_stats ( void );
int stats_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int stats_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../status.c */
int status_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int status_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int status_btn_stop ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int status_realized ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_button_press.c */
void damage_current_bitmap ( void );
int zoom_button_press ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_destroyed.c */
int zoom_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_realized.c */
int zoom_realized ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_redraw.c */
void do_zoom_redraw ( void );
int zoom_redraw ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_resize.c */
void do_zoom_resize ( const BOOL first , const int x_delta , const int y_delta );
int zoom_resize ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_scroll_x.c */
int zoom_scroll_x ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_scroll_y.c */
int zoom_scroll_y ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_setup.c */
int zoom_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../zoom_window.c */
int zoom_window ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../utils.c */
int message ( const char *title , const char *fmt , ...);
void *app_calloc ( const size_t nb , const size_t sz );
void *app_realloc ( void **ptr , const size_t sz );
void *app_malloc ( const size_t sz );
void setBtn ( const PtWidget_t *wgt , const BOOL state );
BOOL isBtnSet ( const PtWidget_t *wgt );
int getWhichBtnSet ( const PtWidget_t *wgt0 , ...);
void setWhichBtnSet ( const int setNo , ...);
void setOnOffBtn ( const PtWidget_t *wgt , const BOOL state );
BOOL isOnOffBtnSet ( const PtWidget_t *wgt );
int ghostBtn ( const PtWidget_t *wgt , const BOOL state );
void setString ( const PtWidget_t *wgt , const char *fmt , ...);
void getString ( const PtWidget_t *wgt , char *string );
void setWindowTitle ( const PtWidget_t *wgt , const char *fmt , ...);
void setColor ( const PtWidget_t *wgt , const PgColor_t color );
int blockWindow ( const PtWidget_t *wgt , const BOOL state );
void setGauge_MinMax ( const PtWidget_t *wgt , const int vmin , const int vmax , const int vcurr );
int getGauge_value ( const PtWidget_t *wgt );
void setGauge_value ( const PtWidget_t *wgt , const int value );
void setCursorType ( const PtWidget_t *wgt , int type );
int busyWindow ( const PtWidget_t *wgt , const BOOL state );
int addListItem ( const PtWidget_t *wgt , const char *fmt , ...);
void getDim ( const PtWidget_t *wgt , USHORT *w , USHORT *h );
void setDim ( const PtWidget_t *wgt , const int w , const int h );
void getPosWidget ( const PtWidget_t *wgt , int *x , int *y );
void setPosWidget ( const PtWidget_t *wgt , const int x , const int y );
void moveByWidget ( PtWidget_t *wgt , const int dx , const int dy );
int getInt ( const PtWidget_t *wgt );
void setInt ( const PtWidget_t *wgt , const int val );
int addItem_list ( const PtWidget_t *wgt , const BOOL is_horo , const int max_nb_kept , const int nb_seen , const char *fmt , ...);
void window_focus ( PtWidget_t *wgt );
void iconify_window ( PtWidget_t *wgt , const BOOL icon );
void getFont ( const PtWidget_t *wgt , char *string );
void getTextExtent ( const PtWidget_t *wgt , PhRect_t *extent );
void get_rel_possiz_window ( PtWidget_t *wgt , int *x , int *y , int *w , int *h );
void set_possiz_window ( PtWidget_t *wgt , const int x , const int y , const int w , const int h );

/* ../comp_gen.asm */
