/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
file_save( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
static	PtFileSelectionInfo_t	infos;
static	BOOL					first = TRUE;
		char					root_dir[ 200], fname[ 300 ];
		FILE					*fp;
		char					_node[ _MAX_NODE + 1 ], _dir[ _MAX_DIR + 1 ],
								_fname[ _MAX_FNAME + 1 ], _ext[ _MAX_EXT + 1 ];
		LIFE_INFOS				life_infos;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Dont' do while computing next generations (Shift-F2) ---*/
	if ( is_comp_generations )
		return( Pt_CONTINUE );

	/*--- Do nothing if option is dimmed ---*/
	if ( Population == 0 )
		return( Pt_CONTINUE );

	/*--- Initialize infos results ---*/
	if ( first )
		{
		memset( &infos, 0, sizeof( infos ) );
		first = FALSE;
		}

	/*--- File dialog selection ---*/
	getcwd( root_dir, sizeof( root_dir ) - 1 );
	if ( PtFileSelection( NULL, NULL, "Save current life", root_dir, "*.life",
		"&Save", "&Cancel", "ndk", &infos,
		Pt_FSDIALOG_NO_FCHECK | Pt_FSDIALOG_NO_UP_BUTTON ) == -1 )
		return( Pt_CONTINUE );

	/*--- Cancel ? ---*/
	if ( infos.ret == Pt_FSDIALOG_BTN2 )
		return( Pt_CONTINUE );

	/*--- Set the current directory ---*/
	_splitpath( infos.path, _node, _dir, _fname, _ext );
	if ( chdir( _dir ) == -1 )
		return( Pt_CONTINUE );

	/*--- Prepare informations to save along with the file ---*/
	memset( &life_infos, 0, sizeof( LIFE_INFOS ) );
	life_infos.software_version = VERSION_NB;
	find_pos_gen( bitmap_to_use(), 
		&life_infos.x1, &life_infos.x2, &life_infos.y1, &life_infos.y2 );
	memmove( &life_infos.lrules, &wrk_lrules, sizeof( LRULES ) );

	/*--- Save now the life ---*/
	if ( !strcmp( _ext, "" ) )
		strcpy( _ext, ".life" );
	_makepath( fname, _node, _dir, _fname, _ext );
	if ( (fp = fopen( fname, "w" )) == NULL )	
		return
			message( "Save a life file", "%s\nError %d saving file.", fname, errno, NULL ),
			fclose( fp ),
			Pt_CONTINUE;
	if ( fwrite( &life_infos, 1, sizeof( LIFE_INFOS ), fp ) != sizeof( LIFE_INFOS ) ||
		 fwrite( bitmap_to_use(), 1, FIELD_SIZE, fp ) != FIELD_SIZE )
		return
			message( "Save a life file", "%s\nError %d saving file.", fname, errno, NULL ),
			fclose( fp ),
			Pt_CONTINUE;
	fclose( fp );

	return( Pt_CONTINUE );

	}	// file_save


#define ISLIVE( x, y ) \
	(life[ ((y) * FIELD_WIDTH8) + ((x) >> 3) ] & mSet[ (x) % 8 ] )

int
file_save_text( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
static	PtFileSelectionInfo_t	infos;
static	BOOL					first = TRUE;
		char					root_dir[ 200], fname[ 300 ];
		FILE					*fp;
		char					_node[ _MAX_NODE + 1 ], _dir[ _MAX_DIR + 1 ],
								_fname[ _MAX_FNAME + 1 ], _ext[ _MAX_EXT + 1 ];
		int						x1, x2, y1, y2;
static	UBYTE					mSet[ 8 ] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };
		int						row, col, z;
		char					line[ FIELD_WIDTH8 + 1 ];
		UBYTE					*life;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Dont' do while computing next generations (Shift-F2) ---*/
	if ( is_comp_generations )
		return( Pt_CONTINUE );

	/*--- Do nothing if option is dimmed ---*/
	if ( Population == 0 )
		return( Pt_CONTINUE );

	/*--- Initialize infos results ---*/
	if ( first )
		{
		memset( &infos, 0, sizeof( infos ) );
		first = FALSE;
		}

	/*--- File dialog selection ---*/
	getcwd( root_dir, sizeof( root_dir ) - 1 );
	if ( PtFileSelection( NULL, NULL, "Save current life", root_dir, "*.txt",
		"&Save", "&Cancel", "ndk", &infos,
		Pt_FSDIALOG_NO_FCHECK | Pt_FSDIALOG_NO_UP_BUTTON ) == -1 )
		return( Pt_CONTINUE );

	/*--- Cancel ? ---*/
	if ( infos.ret == Pt_FSDIALOG_BTN2 )
		return( Pt_CONTINUE );

	/*--- Set the current directory ---*/
	_splitpath( infos.path, _node, _dir, _fname, _ext );
	if ( chdir( _dir ) == -1 )
		return( Pt_CONTINUE );

	/*--- The size of the generation ---*/
	find_pos_gen( life = bitmap_to_use(), &x1, &x2, &y1, &y2 );

	/*--- Create the text file ---*/
	if ( !strcmp( _ext, "" ) )
		strcpy( _ext, ".txt" );
	_makepath( fname, _node, _dir, _fname, _ext );
	if ( (fp = fopen( fname, "w" )) == NULL )	
		return
			message( "Save a life file", "%s\nError %d saving file.", fname, errno, NULL ),
			fclose( fp ),
			Pt_CONTINUE;

	/*--- Save now the life ---*/
	for ( row = x1; row <= x2; row++ )
		{
		for ( z = 0, col = y1; col <= y2; col++ )
			line[ z++ ] = (ISLIVE( col, row ) ? 'o' : '.');
		line[ z ] = 0;
		fprintf( fp, "%s\n", line );
		}	// for (row)
	fclose( fp );

	return( Pt_CONTINUE );

	}	// file_save_text
