/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


void do_life_center( void )
	{
	USHORT		*max_x, *max_y;
	USHORT		new_x, new_y;
	PtArg_t		args[ 5 ];
	PhDim_t		*dim;
	USHORT		*width_sbar, *height_sbar;

	/*--- Center the pan zoom into the zoom field ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_SCROLL_AREA_MAX_X, &max_x, 0 );
	PtSetArg( &args[ 1 ], Pt_ARG_SCROLL_AREA_MAX_Y, &max_y, 0 );
	PtSetArg( &args[ 2 ], Pt_ARG_DIM, &dim, 0 );
	PtSetArg( &args[ 3 ], Pt_ARG_SCROLLBAR_Y_WIDTH, &width_sbar, 0 );
	PtSetArg( &args[ 4 ], Pt_ARG_SCROLLBAR_X_HEIGHT, &height_sbar, 0 );
	PtGetResources( ABW_life_scrollarea, 5, args );
	new_x = ((*max_x + *width_sbar + 2)  - dim->w) / 2;
	new_y = ((*max_y + *height_sbar + 2) - dim->h) / 2;
	PtSetArg( &args[ 0 ], Pt_ARG_SCROLL_AREA_POS_X, new_x, 0 );
	PtSetArg( &args[ 1 ], Pt_ARG_SCROLL_AREA_POS_Y, new_y, 0 );
	PtSetResources( ABW_life_scrollarea, 2, args );

	}	// do_life_center


int
life_center_zoom( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Center the pan zoom into the zoom field ---*/
	zoom_start_x = MULT8( (FIELD_WIDTH  - zoomed_cells_width_nb) / 2 );
	set_zoom_xscrollbar( zoom_start_x );
	zoom_start_y = (FIELD_HEIGHT - zoomed_cells_height_nb) / 2;
	set_zoom_yscrollbar( zoom_start_y );
	resize_pan();

	/*--- Center the pan zoom into the zoom field ---*/
	do_life_center();

	/*--- Redraw the zoom area ---*/
	do_zoom_redraw();

	return( Pt_CONTINUE );

	}

