/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
life_resize( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
		PtContainerCallback_t	*infos = (PtContainerCallback_t *)cbinfo->cbdata;
		int						x_delta, y_delta;
		PhArea_t				*old_area, new_area;
		PtArg_t					args[ 1 ];
static	BOOL					first = TRUE;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Compute the difference ---*/
	x_delta = (infos->new_size.lr.x - infos->old_size.lr.x);
	y_delta = (infos->new_size.lr.y - infos->old_size.lr.y);

	/*--- Resize (in height only) the scroll area ---*/
	if ( !first )
		{
		PtSetArg( &args[ 0 ], Pt_ARG_AREA, &old_area, 0 );
		PtGetResources( ABW_life_scrollarea, 1, args );
		memmove( &new_area, old_area, sizeof( PhArea_t ) );
		new_area.size.h += y_delta;
		new_area.size.w += x_delta;
		PtSetArg( &args[ 0 ], Pt_ARG_AREA, &new_area, 0 );
		PtSetResources( ABW_life_scrollarea, 1, args );
		}

	/*--- Reset first-time flag ---*/
	first = FALSE;

	return( Pt_CONTINUE );

	}

