/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
life_restoregen0( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Nothing to do ? ---*/
	if ( (Generation == 0) && (Population == 0) )
		return( Pt_CONTINUE );

	/*--- Life field: Reset informations (Generation, Population) ---*/
	setString( ABW_status_gen, "%d", Generation = 0 );
	setString( ABW_status_pop, "%d", Population = 0 );
	setString( ABW_status_birth, "" );
	setString( ABW_status_death, "" );

	/*--- Clear all cells of the bitmaps #1 and #2---*/
	clear_field();

	/*--- Center the pan zoom into the life field ---*/
	zoom_start_x = MULT8( (FIELD_WIDTH  - zoomed_cells_width_nb) / 2 );
	set_zoom_xscrollbar( zoom_start_x );
	zoom_start_y = (FIELD_HEIGHT - zoomed_cells_height_nb) / 2;
	set_zoom_yscrollbar( zoom_start_y );
	resize_pan();

	/*--- Life field: Clear stable infos ---*/
	PtUnrealizeWidget( ABW_status_stable_label );
	PtUnrealizeWidget( ABW_status_stable_period );

	/*--- Generations kept to see if stability ---*/
	gen_kept_nb = 0;
	is_stability = FALSE;

	/*--- Initialize statistics ---*/
	memset( &gstats, 0, sizeof( STATS ) );

	/*--- Reload saved generation #0 ---*/
	GENMOVE( bitmap_to_use(), gen0_kept );

	/*--- Show the current bitmap ---*/
	damage_current_bitmap();
	show_life( 1 );

	/*--- Redraw the zoom area ---*/
	do_zoom_redraw();

	/*--- Count the number of cells inside the field ---*/
	setString( ABW_status_pop, "%d", 
		Population = count_nb_cells( bitmap_to_use() ) );

	/*--- Enable/Disable option 'Save' of the menu ---*/
	ApModifyItemState( &file_menu, 
		(Population > 0) ? AB_ITEM_NORMAL : AB_ITEM_DIM, 
		ABN_file_save, ABN_file_save_text, ABN_file_print,
		NULL );

	/*--- Disable option 'Prev generation' of the menu ---*/
	ApModifyItemState( &life_menu, 
		AB_ITEM_DIM, 
		ABN_life_prev, ABN_life_restoregen0,
		NULL );

	return( Pt_CONTINUE );

	}

