/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
options_grid( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Change the shown state ---*/
	if ( isBtnSet( widget ) )
		ApModifyItemState( &options_menu, AB_ITEM_SET,    ABN_options_grid, NULL );
	else
		ApModifyItemState( &options_menu, AB_ITEM_NORMAL, ABN_options_grid, NULL );

	/*--- Keep trace of the options flag (menu) ---*/
	is_grid = isBtnSet( widget );

	return( Pt_CONTINUE );

	}


int
options_grid_racc( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Change the shown state ---*/
	if ( !is_grid )
		ApModifyItemState( &options_menu, AB_ITEM_SET, ABN_options_grid, NULL );
	else
		ApModifyItemState( &options_menu, AB_ITEM_NORMAL, ABN_options_grid, NULL );

	/*--- Keep trace of the options flag (menu) ---*/
	is_grid = !is_grid;

	/*--- Redraw all the zoom area ---*/
	do_zoom_redraw();

	return( Pt_CONTINUE );

	}

int
options_settings( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Dialog already mounted ? ---*/
	if ( ABW_settings != NULL )
		return( Pt_CONTINUE );

	/*--- Mount the dialog ---*/
	ApCreateModule( ABM_settings, NULL, NULL );

	return( Pt_CONTINUE );

	}	// options_settings

int
options_double_buffer( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

