/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
prev_gen( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- No previous generation ? ---*/
	if ( (Generation == 0) || (gen_kept_nb == 0) )
		return( Pt_CONTINUE );

	/*--- Restore the generations kept to see if ... ---*/
	if ( (--Generation % 2) == 1 )
		{
		GENMOVE( field2, gen_kept[ --gen_kept_nb ] );
		show_life( 2 );
		}
	else
		{
		GENMOVE( field1, gen_kept[ --gen_kept_nb ] );
		show_life( 1 );
		}

	/*--- Count the number of cells inside the field and show it ---*/
	setString( ABW_status_pop, "%d", 
		Population = count_nb_cells( bitmap_to_use() ) );
	setString( ABW_status_birth, "" );
	setString( ABW_status_death, "" );

	/*--- Life field: Clear stable infos ---*/
	PtUnrealizeWidget( ABW_status_stable_label );
	PtUnrealizeWidget( ABW_status_stable_period );

	/*--- Generations kept to see if stability ---*/
	is_stability = FALSE;

	/*--- Life field: Draw informations (Generation, Population) ---*/
	setString( ABW_status_gen, "%d", Generation );
	setString( ABW_status_pop, "%d", Population );
	setString( ABW_status_birth, "" );
	setString( ABW_status_death, "" );

	/*--- Redraw the zoom pane ---*/
	do_zoom_redraw();

	/*--- Optimization ---*/
	opt_x1 = 1;
	opt_x2 = FIELD_WIDTH8 - 2;
	opt_y1 = 1;
	opt_y2 = FIELD_HEIGHT - 2;

	/*--- Update the graphic display ? ---*/
	if ( (ABW_graph != NULL) && (!is_comp_generations) )
		graph_redraw();	
	
	return( Pt_CONTINUE );

	}	// prev_gen
