/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


void seek_do_reloadgen( UBYTE *gen_kept, PtWidget_t *wgt )
	{

	/*--- Clear life ---*/
	do_life_clear();

	/*--- Reload saved generation ---*/
	GENMOVE( bitmap_to_use(), gen_kept );

	/*--- Redraw the zoom area ---*/
	do_zoom_redraw();

	/*--- Count the number of cells inside the field ---*/
	setString( ABW_status_pop, "%d", 
		Population = count_nb_cells( bitmap_to_use() ) );

	/*--- Enable/Disable option 'Save' of the menu ---*/
	ApModifyItemState( &file_menu, 
		(Population > 0) ? AB_ITEM_NORMAL : AB_ITEM_DIM, 
		ABN_file_save, ABN_file_save_text, ABN_file_print,
		NULL );

	/*--- Disable option 'Restore previous generation' of the menu ---*/
	ApModifyItemState( &life_menu, 
		AB_ITEM_DIM, 
		ABN_life_prev, ABN_life_restoregen0,
		NULL );

	/*--- Disable the button 'Reload starting generation' ---*/
	ghostBtn( wgt, TRUE );

	}	// seek_do_reloadgen


int
seek_btn_reloadstartgen( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Reload starting generation ---*/
	seek_do_reloadgen( gen_start_kept_seek, ABW_seek_btn_reloadstartgen );

	return( Pt_CONTINUE );

	}	// seek_btn_reloadstartgen
