/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
seek_btn_start( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
		int			stop_at, new_stop_at;
		char		old_item[ 200 ], new_item[ 200 ];
		char		*old_items[ 1 ], *new_items[ 1 ];
		time_t		now;
		struct tm	*tm;
static	BOOL		stop;
		int			best;
		int			try;
		PtArg_t		args[ 2 ];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Computing ? ---*/
	if ( is_comp_generations )
		{
		stop = TRUE;
		return( Pt_CONTINUE );
		}

	/*--- Read all values set by the user ---*/
	stop_at  = getInt( ABW_seek_stop_at );

	/*--- Disable all access to the zoom window ---*/
	busyWindow( ABW_zoom, TRUE );

	/*--- Show 'Stop' button on life field window ---*/
	PtRealizeWidget( ABW_status_btn_stop );
	setString( ABW_status_btn_stop, "Stop" );

	/*--- Then block all input, but 'Stop' ---*/
	setString( ABW_seek_btn_start, "Stop\nseeking" );
	ghostBtn( ABW_seek_btn_genrnd, TRUE );
	ghostBtn( ABW_seek_btn_cancel, TRUE );
	ghostBtn( ABW_seek_btn_reloadstartgen, TRUE );
	ghostBtn( ABW_seek_btn_reloadbestgen,  TRUE );
	busyWindow( ABW_seek_pane_initgen, TRUE );

	/*--- Progression bars ---*/
	PtUnrealizeWidget( ABW_status_lrules );
	PtRealizeWidget( ABW_status_progr_best );
	setGauge_MinMax( ABW_status_progr_best, 1, stop_at, 1 );

	/*--- Iconify the zoom window ---*/
	iconify_window( ABW_zoom, TRUE );

	/*--- Hide the graphics window if opened ---*/
	if ( ABW_graph != NULL )
		PtUnrealizeWidget( ABW_graph );

	/*--- Close the stats window if opened ---*/
	if ( ABW_stats != NULL )
		PtDestroyWidget( ABW_stats );

	/*--- Disable the 'CLOSE' button on the window ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_WINDOW_MANAGED_FLAGS, Pt_FALSE, Ph_WM_CLOSE );
	PtSetArg( &args[ 1 ], Pt_ARG_WINDOW_RENDER_FLAGS,  Pt_FALSE, Ph_WM_RENDER_CLOSE );
	PtSetResources( ABW_seek, 2, args );

	/*--- Try until we reach the asked generation ---*/
	Generation = 0;
	stop = FALSE;
	best = 0;
	try = 0;
	end_comp_generations = FALSE;
	while ( (Generation < stop_at) && (!stop) )
		{

		/*--- Ask to stop ? ---*/
		if ( end_comp_generations )
			break;

		/*--- First clear generation ---*/
		do_life_clear();

		/*--- Compute a random generation and save-it ---*/
		compute_random_generation(
			getInt( ABW_seek_size_width1),   getInt( ABW_seek_size_width2), 
			getInt( ABW_seek_size_height1 ), getInt( ABW_seek_size_height2 ),
			getInt( ABW_seek_pop_min ),      getInt( ABW_seek_pop_max ) );

		/*--- Update list infos ---*/
		time( &now );
		tm = localtime( &now );
		sprintf( old_item, "%02d:%02d:%02d Try #%d ...", 
			tm->tm_hour, tm->tm_min, tm->tm_sec,
			++try );
		addItem_list( ABW_seek_infos, FALSE, 100, 4, "%s", old_item );

		/*--- Set to TRUE while computing next generations (Shift-F2) ---*/
		is_comp_generations = TRUE;

		/*--- Life field: Clear stable infos ---*/
		PtUnrealizeWidget( ABW_status_stable_label );
		PtUnrealizeWidget( ABW_status_stable_period );

		/*--- Generations kept to see if stability ---*/
		is_stability = FALSE;

		/*--- Progression bars ---*/
		PtRealizeWidget( ABW_status_progr_curr );
		setGauge_MinMax( ABW_status_progr_curr, 1, stop_at, 1 );

		/*--- Compute next generations until 
		      - the button 'Stop' is pressed
			  - the generation is stable or dead. ---*/
		for ( end_comp_generations = FALSE; !end_comp_generations && !stop; )
			{

			/*--- Stop-at has changed ? ---*/
			if ( (new_stop_at  = getInt( ABW_seek_stop_at )) != stop_at )
				{
				setGauge_MinMax( ABW_status_progr_best, 1, stop_at = new_stop_at, best );
				if ( Generation >= stop_at )
					break;
				setGauge_MinMax( ABW_status_progr_curr, 1, stop_at, Generation );
				}
			else
				setGauge_value( ABW_status_progr_curr, Generation );

			/*--- Compute the next generation ---*/
			do_compute_next_gen( TRUE );

			/*--- Let Photon handle pending events ---*/
			PtBkgdHandlerProcess();
		
			/*--- End if no population or stability ---*/
			if ( (Population == 0) || (is_stability) )
				break;

			/*--- End if we reach generation asked ---*/
			if ( Generation >= stop_at )
				break;

			}	// for (;;)
		is_comp_generations = FALSE;

		/*--- Update progression bars ---*/
		if ( Generation > best )
			{
			setGauge_value( ABW_status_progr_best, best = Generation );
			GENMOVE( gen_best_kept_seek, gen_start_kept_seek );
			}	// if

		/*--- Update list infos ---*/
		strcpy( new_item, old_item );
		if ( Population == 0 )
			sprintf( &new_item[ strlen( new_item ) - 3], " Reach gen %d. Dead !", 
				Generation );
		else if ( !is_stability )
			sprintf( &new_item[ strlen( new_item ) - 3], " Reach gen %d", 
				Generation );
		else
			sprintf( &new_item[ strlen( new_item ) - 3], " Reach gen %d. Stable: period=%d", 
				Generation, stability_period );
		old_items[ 0 ] = old_item;
		new_items[ 0 ] = new_item;
		PtListReplaceItems( ABW_seek_infos, old_items, new_items, 1 );

		}	// while (Generation != stop_at )

	/*--- Stop computing generations ---*/
	PtUnrealizeWidget( ABW_status_btn_stop );

	/*--- Des-hide the graphics window if opened ---*/
	if ( ABW_graph != NULL )
		PtRealizeWidget( ABW_graph );

	/*--- Restore access to the zoom window ---*/
	busyWindow( ABW_zoom, FALSE );

	/*--- If seek window is open, then unblock all input ---*/
	/*--- Enable the button 'Reload starting generation', only of seek window is open ---*/
	setString( ABW_seek_btn_start, "Start\nseeking" );
	ghostBtn( ABW_seek_btn_genrnd, FALSE );
	ghostBtn( ABW_seek_btn_cancel, FALSE );
	ghostBtn( ABW_seek_btn_reloadstartgen, FALSE );
	ghostBtn( ABW_seek_btn_reloadbestgen, FALSE );
	busyWindow( ABW_seek_pane_initgen, FALSE );

	/*--- Progression bars ---*/
	PtUnrealizeWidget( ABW_status_progr_best );
	PtUnrealizeWidget( ABW_status_progr_curr );
	PtRealizeWidget( ABW_status_lrules );

	/*--- Enable/Disable option 'Save' of the menu ---*/
	ApModifyItemState( &file_menu, 
		(Population > 0) ? AB_ITEM_NORMAL : AB_ITEM_DIM, 
		ABN_file_save, ABN_file_print,
		NULL );
	ApModifyItemState( &life_menu, 
		(Population > 0) ? AB_ITEM_NORMAL : AB_ITEM_DIM, 
		ABN_life_prev, ABN_life_restoregen0,
		NULL );

	/*--- Re-enable the 'CLOSE' button on the window ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_WINDOW_MANAGED_FLAGS, Pt_TRUE, Ph_WM_CLOSE );
	PtSetArg( &args[ 1 ], Pt_ARG_WINDOW_RENDER_FLAGS,  Pt_TRUE, Ph_WM_RENDER_CLOSE );
	PtSetResources( ABW_seek, 2, args );

	/*--- Des-Iconify the zoom window ---*/
	iconify_window( ABW_zoom, FALSE );

	return( Pt_CONTINUE );

	}	// seek_btn_start
