/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


static void save_values_ini( void )
	{
	char		temp[ 100 ];

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_WRITE ) == Pt_FALSE )
		return;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_SEEK );

	/*--- Initial generation ---*/
	sprintf( temp, "%d,%d,%d,%d,%d,%d,%d",
		getInt( ABW_seek_size_width1 ), getInt( ABW_seek_size_width2 ), 
		getInt( ABW_seek_size_height1 ), getInt( ABW_seek_size_height2 ),
		getInt( ABW_seek_pop_min ), getInt( ABW_seek_pop_max ),
		getWhichBtnSet( ABW_seek_symetry_none, ABW_seek_symetry_hor,
			ABW_seek_symetry_vert, ABW_seek_symetry_both, NULL ) );
	PxConfigWriteString( CFG_SECTION_SEEK, "Initial generation", PXCONFIG_FMT_STRING, temp );

	/*--- Stop ---*/
	sprintf( temp, "%d", getInt( ABW_seek_stop_at ) );
	PxConfigWriteString( CFG_SECTION_SEEK, "Stop at", PXCONFIG_FMT_STRING, temp );

	/*--- Close the configuration file ---*/
	PxConfigClose();
	
	}	// save_values_ini


int
seek_destroyed( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Save position and dimension of this window into the config (life.ini) file ---*/
	save_posdim_in_config_file( "Seek window", ABW_seek );

	/*--- Save current values into the .ini file ---*/
	save_values_ini();

	/*--- Dialog not mounted ---*/
	ABW_seek = NULL;

	return( Pt_CONTINUE );

	}
