/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int restore_values_ini( void )
	{
	char	temp[ 100 ];
	int		size_width1, size_width2, 
			size_height1, size_height2, 
			pop_min, pop_max, 
			symetry;
	int		stop_at;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_READ ) == Pt_FALSE )
		return -1;

	/*--- Initial Generation ---*/	
	PxConfigSection( CFG_SECTION_SEEK );
	if ( PxConfigReadString( CFG_SECTION_SEEK, "Initial generation", "", 
		temp, sizeof( temp ) - 1 ) == NULL )
		{
		PxConfigClose();
		return -1;
		}
	else
		if ( sscanf( temp, "%d,%d,%d,%d,%d,%d,%d", &size_width1, &size_width2, 
			&size_height1, &size_height2, &pop_min, &pop_max, &symetry ) != 7 )
			{
			PxConfigClose();
			return -1;
			}
	setInt( ABW_seek_size_width1, size_width1 );
	setInt( ABW_seek_size_width2, size_width2 );
	setInt( ABW_seek_size_height1, size_height1 );
	setInt( ABW_seek_size_height2, size_height2 );
	setInt( ABW_seek_pop_min, pop_min );
	setInt( ABW_seek_pop_max, pop_max );
	setWhichBtnSet( symetry, ABW_seek_symetry_none, ABW_seek_symetry_hor,
			ABW_seek_symetry_vert, ABW_seek_symetry_both, NULL );

	/*--- Stop ---*/
	if ( PxConfigReadString( CFG_SECTION_SEEK, "Stop at", "", 
		temp, sizeof( temp ) - 1 ) == NULL )
		{
		PxConfigClose();
		return -1;
		}
	else
		if ( sscanf( temp, "%d", &stop_at ) != 1 )
			{
			PxConfigClose();
			return -1;
			}
	setInt( ABW_seek_stop_at, stop_at );

	/*--- Close the configuration file ---*/
	PxConfigClose();

	return 0;
	
	}	// restore_values_ini


int
seek_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Set the Position/Size of the seek window if given in the .ini file ---*/
	readandset_cfg_szpos( "Seek window", ABW_seek );

	/*--- Get current values from the .ini file ---*/
	restore_values_ini();

	return( Pt_CONTINUE );

	}
