/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


void show_stats( void )
	{

	/*--- Dialog not mounted ? ---*/	
	if ( !ABW_stats )
		return;

	/*--- Average Population ---*/
	if ( Generation == 0 )
		setString( ABW_stats_avg_pop, "" );
	else
		setString( ABW_stats_avg_pop, "%d", gstats.total_pop / Generation );

	/*--- Average Number of Births ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_nbbirths, "" );
	else
		setString( ABW_stats_avg_nbbirths, "%d", gstats.total_births / Generation );

	/*--- Average Number of Deaths ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_nbdeaths, "" );
	else
		setString( ABW_stats_avg_nbdeaths, "%d", gstats.total_deaths / Generation );

	/*--- Average Number of Survival ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_surviv, "" );
	else
		setString( ABW_stats_avg_surviv, "%d", gstats.total_surviv / Generation );

	/*--- Average Compute time ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_ctime, "" );
	else
		setString( ABW_stats_avg_ctime, "%d", gstats.total_ctime / Generation );

	/*--- Average Drawing time ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_dtime, "" );
	else
		setString( ABW_stats_avg_dtime, "%d", gstats.total_dtime / Generation );

	/*--- Average Drawing time ---*/	
	if ( Generation == 0 )
		setString( ABW_stats_avg_ttime, "" );
	else
		setString( ABW_stats_avg_ttime, "%d", gstats.total_ttime / Generation );

	/*--- In case of Alt-F2 (Automatic, Next Generations), time elapsed ---*/
	if ( nextgens_timeelps != (time_t)-1 )
		setString( ABW_stats_lastnextgens, "%d", nextgens_timeelps );
	else
		setString( ABW_stats_lastnextgens, "" );

	}	// show_stats


int
stats_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Set the Position/Size of the window if given in the .ini file ---*/
	readandset_cfg_szpos( "Stats window", ABW_stats );

	/*--- Update the seek window is opened ---*/
	if ( ABW_seek != NULL )
		setBtn( ABW_seek_is_showstats, TRUE );

	/*--- Update the stats fields ---*/
	show_stats();

	return( Pt_CONTINUE );

	}	// stats_setup


int
stats_destroyed( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Save position and dimension of this window into the config (life.ini) file ---*/
	save_posdim_in_config_file( "Stats window", ABW_stats );

	/*--- Update the seek window is opened ---*/
	if ( ABW_seek != NULL )
		setBtn( ABW_seek_is_showstats, FALSE );

	/*--- Dialog not mounted ---*/
	ABW_stats = NULL;

	return( Pt_CONTINUE );

	}	// stats_destroyed
