/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


/*--- Show the current bitmap ---*/
void damage_current_bitmap( void )
	{

	if ( (Generation % 2) == 0 )
		PtDamageWidget( ABW_life_bmp1 );
	else
		PtDamageWidget( ABW_life_bmp2 );

	}	// damage_current_bitmap


int
zoom_button_press( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
		PhRect_t		*rect;
		int				cx,cy;
		int				x, y;
		int				dx, dy;
		BOOL			ok;
		PhPoint_t		center;
		PhPoint_t		abs_radii, pres_radii;
		PtArg_t			args[ 1 ];
		char			*ptr, *p;
static	UBYTE			mask[ 8 ]  = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };
static	UBYTE			clear[ 8 ] = { 0x7F, 0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0xFE };
static	BOOL			first = TRUE;
static	PgColor_t		wnd_foreground_color;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Get the current position of the mouse pointer ---*/
	rect = PhGetRects( cbinfo->event );
	cx = rect->ul.x;
	cy = rect->ul.y;

	/*--- Convert into logical coord. ---*/
	x = cx / (CELLZ_WIDTH  + CELLZ_XGAP);
	y = cy / (CELLZ_HEIGHT + CELLZ_YGAP);

	/*--- The border around the field ? ---*/
	if ( (zoom_start_x + x < 8) || (zoom_start_x + x >= (FIELD_WIDTH-8)) ||
		 (zoom_start_y + y == 0) || (zoom_start_y +y == (FIELD_HEIGHT-1)) )
		return( Pt_CONTINUE );

	/*--- Change the cursor spot on a cell only ---*/
	dx = cx % (CELLZ_WIDTH  + CELLZ_XGAP);
	dy = cy % (CELLZ_HEIGHT + CELLZ_YGAP);
	if ( (dx < CELLZ_XGAP2) || (dx > (CELLZ_WIDTH-CELLZ_XGAP2)) ||
		 (dy < CELLZ_YGAP2) || (dy > (CELLZ_HEIGHT-CELLZ_YGAP2)) )
		ok = FALSE;
	else
		ok = TRUE;

	/*--- The bitmap to use ---*/
	ptr = bitmap_to_use();

	/*--- First, get the window foreground color ---*/
	if ( first )
		{
		PgColor_t	*color;
		PtSetArg( &args[ 0 ], Pt_ARG_FILL_COLOR, &color, 0 );
		PtGetResources( ABW_zoom, 1, args );
		memmove( &wnd_foreground_color, color, sizeof( PgColor_t ) );
		first = FALSE;
		}	// if

	/*--- Draw/Erase the cell into the zoom area - See: zoom_redraw.c ---*/
	PgSetRegion( PtWidgetRid( ABW_zoom_area ) );
	pres_radii.x  = 4;
	pres_radii.y  = 5;
	abs_radii.x  = 2;
	abs_radii.y  = 2;
	center.x = ((CELLZ_WIDTH + CELLZ_XGAP) * (2*x+1) ) / 2 ;
	center.y = ((CELLZ_HEIGHT  + CELLZ_YGAP) * (2*y+1) ) / 2;
	p = &ptr[ (zoom_start_y * FIELD_WIDTH8) + (zoom_start_x / 8) + (y * FIELD_WIDTH8) + ( x / 8) ];
	if ( *p & mask[ x % 8 ] )
		{

		/*--- Clear the cell into the zoom area ---*/
		*p &= clear[ x % 8 ];
		PgSetFillColor( wnd_foreground_color );
		PgSetStrokeColor( wnd_foreground_color );
		PgDrawEllipse( &center, &pres_radii, Pg_DRAW_FILL );
		if ( is_grid )
			{
			PgSetFillColor( Pg_RED );
			PgSetStrokeColor( Pg_RED );
			PgDrawEllipse( &center, &abs_radii, Pg_DRAW_FILL );
			}

		/*--- Update the number of cells ---*/
		setString( ABW_status_pop, "%d", --Population );

		}
	else
		{

		/*--- Clear the cell into the zoom area ---*/
		*p |= mask[ x % 8 ];
		PgSetFillColor( Pg_RED );
		PgSetStrokeColor( Pg_RED );
		PgDrawEllipse( &center, &pres_radii, Pg_DRAW_FILL );

		/*--- Update the number of cells ---*/
		setString( ABW_status_pop, "%d", ++Population );

		}
	PgFlush();
	if ( (Generation % 2) == 0 )
		PtDamageWidget( ABW_life_bmp1 );
	else
		PtDamageWidget( ABW_life_bmp2 );
	damage_current_bitmap();

	/*--- Enable/Disable option 'Save' of the menu ---*/
	ApModifyItemState( &file_menu, 
		(Population > 0) ? AB_ITEM_NORMAL : AB_ITEM_DIM, 
		ABN_file_save, ABN_file_save_text, ABN_file_print,
		NULL );

	return( Pt_CONTINUE );

	}	// zoom_button_press
