/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


int
zoom_realized( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Get options. If not exist, show help window ---*/
	if ( read_cfg_options() == Pt_FALSE )
		ApCreateModule( ABM_rules, NULL, NULL );

	/*--- Center the pan zoom into the life field ---*/
	zoom_start_x = MULT8( (FIELD_WIDTH  - zoomed_cells_width_nb) / 2 );
	set_zoom_xscrollbar( zoom_start_x );
	zoom_start_y = (FIELD_HEIGHT - zoomed_cells_height_nb) / 2;
	set_zoom_yscrollbar( zoom_start_y );

	/*--- Change the position and the size of the pan rectangle ---*/
	resize_pan();

	/*--- Redraw all the zoom area (To have the grid, if needed) ---*/
	do_zoom_redraw();

	return( Pt_CONTINUE );

	}	// zoom_realized
