/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


void do_zoom_redraw( void )

	{
		int			x, y;
		PhPoint_t	center;
		PhPoint_t	abs_radii, pres_radii;
		PtArg_t		args[ 1 ];
		char		**field, *ptr, *p;
static	UBYTE		mask[ 8 ] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };
static	BOOL		first = TRUE;
static	PgColor_t	wnd_foreground_color;
		long		state;

	/*--- Do nothing if the window is iconified or hidden ---*/
	if ( ((state = PtWindowGetState( ABW_zoom )) & Ph_WM_STATE_ISICONIFIED) ||
		(state & Ph_WM_STATE_ISHIDDEN) )
		return;		

	/*--- First, get the window foreground color ---*/
	if ( first )
		{
		PgColor_t	*color;
		PtSetArg( &args[ 0 ], Pt_ARG_FILL_COLOR, &color, 0 );
		PtGetResources( ABW_zoom, 1, args );
		memmove( &wnd_foreground_color, color, sizeof( PgColor_t ) );
		first = FALSE;
		}	// if

	/*--- The bitmap to use ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_BITMAP_DATA, &field, 0 );
	if ( (Generation % 2) == 0 )
		ptr = field1;
	else
		ptr = field2;

	/*--- Create all the widgets for zoomed cells ---*/
	PgSetRegion( PtWidgetRid( ABW_zoom_area ) );
	pres_radii.x  = 4;
	pres_radii.y  = 5;
	abs_radii.x  = 2;
	abs_radii.y  = 2;
	for ( x = 0; x < zoomed_cells_width_nb; x++ )
		{
		center.x = ((CELLZ_WIDTH + CELLZ_XGAP) * (2*x+1) ) / 2 ;
		for ( y = 0; y < zoomed_cells_height_nb; y++ )
			{
			center.y = ((CELLZ_HEIGHT  + CELLZ_YGAP) * (2*y+1) ) / 2;
			p = &ptr[ (zoom_start_y * FIELD_WIDTH8) + (zoom_start_x / 8) + (y * FIELD_WIDTH8) + ( x / 8) ];
			if ( *p & mask[ x % 8 ] )
				{
				PgSetFillColor( Pg_RED );
				PgSetStrokeColor( Pg_RED );
				PgDrawEllipse( &center, &pres_radii, Pg_DRAW_FILL );
				}
			else
				{
				PgSetFillColor( wnd_foreground_color );
				PgSetStrokeColor( wnd_foreground_color );
				PgDrawEllipse( &center, &pres_radii, Pg_DRAW_FILL );
				if ( is_grid )
					{
					if ( (zoom_start_x + x < 8) || (zoom_start_x + x >= (FIELD_WIDTH-8)) ||
						 (zoom_start_y + y == 0) || (zoom_start_y +y == (FIELD_HEIGHT-1)) )
						{
						PgSetFillColor( Pg_DGREY );
						PgSetStrokeColor( Pg_DGREY );
						}
					else
						{
						PgSetFillColor( Pg_RED );
						PgSetStrokeColor( Pg_RED );
						}
					PgDrawEllipse( &center, &abs_radii, Pg_DRAW_FILL );
					}
				}
			}
		}
	PgFlush();

	}	// do_zoom_redraw


int
zoom_redraw( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Redraw all the zoom area ---*/
	do_zoom_redraw();

	return( Pt_CONTINUE );

	}
