/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "life.h"
#include "abimport.h"
#include "proto.h"


static int initial_size_zoom( void )
	{
	PhRect_t	rect;
	PhDim_t		screen_size;
	static int	coefs[][ 3 ] =
		{
		{  640, 280, 210 },
		{  800, 360, 270 },
		{ 1024, 460, 350 },
		};
	int			k;
	BOOL		found;
	USHORT		initial_width, initial_height;
	int			x_delta, y_delta;

	/*--- Get the screen size ---*/	
	PhWindowQueryVisible( Ph_QUERY_INPUT_GROUP, 0, 0, &rect );
	screen_size.w = (rect.lr.x - rect.ul.x + 1);
	screen_size.h = (rect.lr.y - rect.ul.y + 1);

	/*--- Adapt the size of the life window ---*/
	for ( found = FALSE, k = 0; k < (sizeof( coefs ) / sizeof( coefs[ 0 ] )); k++ )
		if ( screen_size.w <= coefs[ k ][ 0 ] )
			{
			found = TRUE;
			break;
			}
	if ( !found )
		return 0;

	/*--- Change the size of the window ---*/
	getDim( ABW_zoom, &initial_width, &initial_height );
	setDim( ABW_zoom, coefs[ k ][ 1 ], coefs[ k ][ 2 ] );

	/*--- Change the position of the window (bottom-right of the screen) ---*/
	x_delta = (initial_width  - coefs[ k ][ 1 ]);
	y_delta = (initial_height - coefs[ k ][ 2 ]);
	moveByWidget( ABW_zoom, x_delta, y_delta );

	/*--- Move the zoom area pane, and also the scrollbars ---*/
	do_zoom_resize( FALSE, -x_delta, -y_delta );

	return 0;
	
	}	// initial_size_zoom


int
zoom_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	USHORT		initial_width, initial_height;
	USHORT		now_width, now_height;
	int			x_delta, y_delta;

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- First disable some options of the menu ---*/
	ApModifyItemState( &file_menu, AB_ITEM_DIM, 
		ABN_file_save, ABN_file_save_text, ABN_file_print,
		NULL );
	ApModifyItemState( &life_menu, AB_ITEM_DIM, 
		ABN_life_prev, ABN_life_restoregen0,
		NULL );

	/*--- Set the Position/Size of the zoom window if given in the .ini file ---*/
	getDim( ABW_zoom, &initial_width, &initial_height );
	if ( readandset_cfg_szpos( "Zoom window", ABW_zoom ) == -1 )
		initial_size_zoom();
	else
		{

		/*--- Move the zoom area pane, and also the scrollbars ---*/
		getDim( ABW_zoom, &now_width, &now_height );
		x_delta = (now_width  - initial_width);
		y_delta = (now_height - initial_height);
		do_zoom_resize( FALSE, x_delta, y_delta );

		}

	return( Pt_CONTINUE );

	}	// zoom_setup
